#<profile4xi profile = "31" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_sharedctypes4xi.py">
#<abstract4xi abstract = "tests sharedctypes4xi"/>
#<verify4xi verification = "10" target = "arrayfunction4xi.py"/>
#<contextualize4xi context = "lock4xi.py; manager4xi.py; pipe4xi.py; pool4xi.py; process4xi.py; queue4xi.py; value4xi.py"/>
#<use4xi usage = "
# SET:
# 1) ack2original <-- True, if you want to use all original multiprocessing modules
# 2) ack2hybrid   <-- True, if you want to hybrid multiprocessing modules
#                           - you can decide which new and original modules you use
#                           + this way you can compare results to those run with ack2original as True
#                           + and thereby find possible errors in new versions   
# 3) ack2original <-- False
#    ack2hybrid   <-- False, if you want to use all new multiprocessing4xi modules 
# 
# RUN:
# > call t  test_sharedctypes4xi > ..\txt\test_sharedctypes4xi.txt
#
# ANALYZE:
# scope-ace-test-sharedctypes4xi.xml <-- scope file (make sure test_noun4xi.py setting is ok)
# sense-test-sharedctypes4xi.xml     <-- trace in XML
# reason-test-sharedctypes4xi.xml
# ace-test-sharedctypes4xi.xml
# test_sharedctypes4xi.txt           <-- OF TEST_SHARED_CTYPES4XI
#"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test_shared_ctypes4xi',
            'set_trace4xi',
            'print_trace4xi',
            'modify3xi',
            'ThreeDimension3Xi',
            'Point4Xi',
            'modify4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
 
from ctypes import Structure, c_double, create_string_buffer
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
try:                             # Source ones
    from multiprocessing.synchronize import Lock
except:
    print("test_sharedctypes4xi.py: *** failed in from multiprocessing.synchronize import Lock ***")
try:                             
    from multiprocessing.sharedctypes import Value
except:
    print("test_sharedctypes4xi.py: *** failed in from multiprocessing.sharedctypes import Value ***")
try:                             
    from multiprocessing.sharedctypes import Array
except:
    print("test_sharedctypes4xi.py: *** failed in from multiprocessing.sharedctypes import Array ***")
   
try:                             
    from multiprocessing.process import Process
except:
    print("test_sharedctypes4xi.py: *** failed in from multiprocessing.process import Process ***")     
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from arrayfunction4xi import ArrayFunction4Xi #<--- note: this must be called (Array4Xi uses the class)
from examine4xi import KB4Examination
from lock4xi import Lock4Xi
from manager4xi import Manager4Xi 
from pipe4xi import Pipe4Xi
from pool4xi import Pool4Xi
from process4xi import Process4Xi
from queue4xi  import Queue4Xi
from valuefunction4xi import ValueFunction4Xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi
global KB4Examination

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
kb2select4test = KB4Examination
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'ArrayFunction4Xi': 'NACK4TRACE',
         'BufferWrapper4Xi': 'NACK4TRACE',
         'Heap4Xi': 'NACK4TRACE',
         'Finalize4Xi': 'NACK4TRACE',
         'Lock4Xi': 'NACK4TRACE',
         'Manager4Xi': 'NACK4TRACE',
         'Pipe4Xi': 'NACK4TRACE',
         'Pool4Xi': 'NACK4TRACE',
         'Popen4Xi': 'NACK4TRACE',
         'Process4Xi': 'NACK4TRACE',
         'Queue4Xi': 'NACK4TRACE',
         'RawArray4Xi': 'NACK4TRACE',
         'RawValue4Xi': 'NACK4TRACE',
         'RLock4Xi': 'NACK4TRACE',
         'rebuild_ctype4xi': 'NACK4TRACE',
         'reduce_ctype4xi': 'NACK4TRACE',
         'SemLock4Xi': 'NACK4TRACE',
         'synchronized_function4xi': 'NACK4TRACE',
         'Value4Xi': 'NACK4TRACE',
         'ValueFunction4Xi': 'NACK4TRACE',
         '_new_value4xi': 'NACK4TRACE'
        }                              

                        
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>            
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(p2xi):
  

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-shared-ctypes4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Shared Ctypes in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Shared Ctypes in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(p2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-shared-ctypes4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Shared Ctypes in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Shared Ctypes in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(p2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-shared-ctypes4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Shared Ctypes in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Shared Ctypes in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(p2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  

                             
# -------------------------------------------------------------------------------------------------
#<class4xi class = "Point" base = "Structure" child = "None"
# synopsis = "3-dimension point structure" usage = "testing shared c-types
#"
#>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
class Point(Structure):
    _fields_ = [('x', c_double), ('y', c_double), ('z', c_double)]
#</class4xi>
                             
# -------------------------------------------------------------------------------------------------
#<class4xi class = "Point4Xi" base = "Structure" child = "None"
# synopsis = "3-dimension point structure" usage = "testing shared c-types
#"
#>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
class Point4Xi(Structure):
    _fields_ = [('x', c_double), ('y', c_double), ('z', c_double)]
#</class4xi>

 
 
# -------------------------------------------------------------------------------------------------
# modify function
#<function function = "modify" usage = "testing shared c-types
#<type type = "
# typecode_to_type = {                           pointer! below
# 'c': ctypes.c_char     b2n=b'Name'; c2n=c_char_p(b2n);name2print=c2n.value.decode("utf-8");print(name2print) => Name
# 'u': ctypes.c_wchar 
# 'b': ctypes.c_byte
# 'B': ctypes.c_ubyte
# 'h': ctypes.c_short
# 'H': ctypes.c_ushort   us2c = c_ushort(-3); print(us2c.value) => 65533
# 'i': ctypes.c_int      int2xi = c_int(42); print(int)==> c_long(42); print(int.value)=>42
# 'I': ctypes.c_uint
# 'l': ctypes.c_long     l2c=c_long(33**33);print(l2c.value)=>942687265
# 'L': ctypes.c_ulong
# 'f': ctypes.c_float    float2xi = c_float(1.22334455); print(float2xi.value)=>1.2233445644378662
# 'd': ctypes.c_double}
#
#  buffer2c = create_string_buffer(b"Hello"); print(buffer2c.value)=>b'Hello'
#  class Point(Structure)
#     _fields_=[("x",c_int),("y",c_int),("z",c_int)]
#  point2xi = Point(10,20,30); print(point2xi.z)=> 30
#" 
#> 
#<state status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def modify(int2modify, double2modify, buffer2modify, vector2modify):

    print("(STEP 0A/33) OF MODIFY OF ORIGINAL TEST_SHAREDCTYPE: started ", time4xi())
    # 05:30:09 04/13/13 Pacific Daylight Time  
    print("(STEP 0B/33) OF MODIFY OF ORIGINAL TEST_SHAREDCTYPE: PASSED INT2MODIFY ", int2modify)
    # <Synchronized wrapper for c_long(7)>
    print("(STEP 0C/33) OF MODIFY OF ORIGINAL TEST_SHAREDCTYPE: PASSED DOUBLE2MODIFY ", double2modify)
    # <Synchronized wrapper for c_double(0.3333333333333333)>
    print("(STEP 0D/33) OF MODIFY OF ORIGINAL TEST_SHAREDCTYPE: PASSED BUFFER2MODIFY ", buffer2modify)
    # <ctypes.c_char_Array_70 object at 0x00000000039FF048>
    print("(STEP 0E/33) OF MODIFY OF ORIGINAL TEST_SHAREDCTYPE: PASSED VECTOR2MODIFY ", vector2modify)
    # <SynchronizedArray wrapper for <multiprocessing.sharedctypes.Point_Array_3 object at 0x00000000039D4F48>>
    
    try:
        int2modify.value **= 2
        print("(STEP 1A/33) OF MODIFY OF ORIGINAL TEST_SHAREDCTYPE: SET VALUE OF INT2MODIFY TO: ", int2modify.value)
        # 49
    except:
        print("(STEP 1Z/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: *** FAILED 1 *** ", time4xi()) 
        
    try:
        double2modify.value **= 2
        print("(STEP 2A/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: SET VALUE OF DOUBLE2MODIFY TO: ", double2modify.value)
        # 0.1111111111111111
    except:
        print("(STEP 2Z/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: *** FAILED 2 *** ", time4xi()) 
    
    try:
        buffer2modify.value = buffer2modify.value + b'@yourdragonxi'
        print("(STEP 3A/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: SET VALUE OF BUFFER2MODIFY TO: ", buffer2modify.value)
        # b'Hello@yourdragonxi'
    except:
        print("(STEP 3Z/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: *** FAILED 3 *** ", time4xi())    
    
    try:                              
        for a in vector2modify:
            try:
                a.x **= 2
                print("(STEP 4A/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: SET VALUE OF X IN VECTOR2MODIFY TO: ", a.x)
                # 3.515625, 33.0625, 5.640625
            except:
                print("(STEP 4Z1/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: *** FAILED WITH X OF VECTOR2MODIFY *** ", time4xi())
            try:    
                a.y **= 4
                print("(STEP 4B/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: SET VALUE OF Y IN VECTOR2MODIFY TO: ", a.y)
                # 1525.87890625, 16.0, 8145.0625
            except:
                print("(STEP 4Z2/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: *** FAILED WITH Y OF VECTOR2MODIFY *** ", time4xi())    
            try:
                a.z **= 8
                print("(STEP 4C/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: SET VALUE OF Z IN VECTOR2MODIFY TO: ", a.z)
                # 39287974783.90154, 10057721544678.795, 2574776715437771.5
            except:
                print("(STEP 4Z3/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: *** FAILED WITH Z OF VECTOR2MODIFY *** ", time4xi()) 
    except:
        print("(STEP 4Z4/33) MODIFY OF ORIGINAL TEST_SHAREDCTYPE: *** FAILED WITH Z OF VECTOR2MODIFY *** ", time4xi())                 

        
    print("(STEP 5/33) OF MODIFY OF ORIGINAL TEST_SHAREDCTYPE: RETURNING  ", time4xi())
    # 05:30:09 04/13/13 Pacific Daylight Time       
#</function>
 
 
# -------------------------------------------------------------------------------------------------
# modify function
#<function4xi function = "modify4xi" usage = "testing shared c-types
#<type4xi type = "
# typecode_to_type = {                           pointer! below
# 'c': ctypes.c_char     b2n=b'Name'; c2n=c_char_p(b2n);name2print=c2n.value.decode("utf-8");print(name2print) => Name
# 'u': ctypes.c_wchar 
# 'b': ctypes.c_byte
# 'B': ctypes.c_ubyte
# 'h': ctypes.c_short
# 'H': ctypes.c_ushort   us2c = c_ushort(-3); print(us2c.value) => 65533
# 'i': ctypes.c_int      int2xi = c_int(42); print(int)==> c_long(42); print(int.value)=>42
# 'I': ctypes.c_uint
# 'l': ctypes.c_long     l2c=c_long(33**33);print(l2c.value)=>942687265
# 'L': ctypes.c_ulong
# 'f': ctypes.c_float    float2xi = c_float(1.22334455); print(float2xi.value)=>1.2233445644378662
# 'd': ctypes.c_double}
#
#  buffer2c = create_string_buffer(b"Hello"); print(buffer2c.value)=>b'Hello'
#  class Point(Structure)
#     _fields_=[("x",c_int),("y",c_int),("z",c_int)]
#  point2xi = Point(10,20,30); print(point2xi.z)=> 30
#" 
#> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def modify4xi(int2modify, double2modify, buffer2modify, vector2modify):

    print("(STEP 0A/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: started ", time4xi()) 
    # 06:41:02 04/15/13 Pacific Daylight Time 
    print("(STEP 0B/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: PASSED INT2MODIFY ", int2modify)
    # <Synchronized4Xi wrapper for c_long(7)>
    print("(STEP 0C/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: PASSED DOUBLE2MODIFY ", double2modify)
    # <Synchronized4Xi wrapper for c_double(0.3333333333333333)>
    print("(STEP 0D/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: PASSED BUFFER2MODIFY ", buffer2modify)
    # <ctypes.c_char_Array_70 object at 0x0000000003925A48>
    print("(STEP 0E/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: PASSED VECTOR2MODIFY ", vector2modify)
    # <SynchronizedArray4Xi wrapper for <rawarray4xi.Point4Xi_Array_3 object at 0x0000000003925848>>
    
    try:
        int2modify.value **= 2
        print("(STEP 1A/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF INT2MODIFY TO: ", int2modify.value)
        # 49
    except:
        print("(STEP 1Z/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: *** FAILED 1 *** ", time4xi()) 
        
    try:
        double2modify.value **= 2
        print("(STEP 2A/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF DOUBLE2MODIFY TO: ", double2modify.value)
        # 0.1111111111111111
    except:
        print("(STEP 2Z/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: *** FAILED 2 *** ", time4xi()) 
    
    try:
        buffer2modify.value = buffer2modify.value + b'@yourdragonxi'
        print("(STEP 3A/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF BUFFER2MODIFY TO: ", buffer2modify.value)
        # b'Hello@yourdragonxi'
    except:
        print("(STEP 3Z/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: *** FAILED 3 *** ", time4xi())    
    
    try:                              
        for a in vector2modify:
            try:
                a.x **= 2
                print("(STEP 4A/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF X IN VECTOR2MODIFY TO: ", a.x)
                # 3.515625, 33.0625, 5.640625
            except:
                print("(STEP 4Z1/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: *** FAILED WITH X OF VECTOR2MODIFY *** ", time4xi())
            try:    
                a.y **= 4
                print("(STEP 4B/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF Y IN VECTOR2MODIFY TO: ", a.y)
                # 1525.87890625, 16.0, 8145.0625
            except:
                print("(STEP 4Z2/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: *** FAILED WITH Y OF VECTOR2MODIFY *** ", time4xi())    
            try:
                a.z **= 8
                print("(STEP 4C/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF Z IN VECTOR2MODIFY TO: ", a.z)
                # 39287974783.90154, 10057721544678.795, 2574776715437771.5
            except:
                print("(STEP 4Z3/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: *** FAILED WITH Z OF VECTOR2MODIFY *** ", time4xi()) 
    except:
        print("(STEP 4Z4/33)MODIFY4XI OF TEST_SHAREDCTYPE4XI: *** FAILED WITH Z OF VECTOR2MODIFY *** ", time4xi())                 

        
    print("(STEP 5/33)MODIFY4XI OF TEST_SHAREDCTYPE4XI: RETURNING  ", time4xi()) 
    # 06:41:02 04/15/13 Pacific Daylight Time      
#</function4xi>

# -------------------------------------------------------------------------------------------------
# ThreeDimension
#<class4xi class = "ThreeDimension" base = "Structure" child = "None" synopsis = "3-dimension structure" usage = "testing shared c-types
#"
#>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
class ThreeDimension(Structure):
    _fields_ = [('x', c_double), ('y', c_double), ('z', c_double)]  

 
#</class4xi>
 
# -------------------------------------------------------------------------------------------------
# ThreeDimension4Xi
#<class4xi class = "ThreeDimension4Xi" base = "Structure" child = "None" synopsis = "3-dimension structure" usage = "testing shared c-types
#"
#>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
class ThreeDimension3Xi(Structure):
    _fields_ = [('x', c_double), ('y', c_double), ('z', c_double)]  

 
#</class4xi>


                
# -------------------------------------------------------------------------------------------------
#<function4 function = "modify2xyz" usage = "
# modify 3-dimension structure without string type
#"
#>
#<state4 status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------     
def modify2xyz(n, vector):
    print("modify2xyz of test_sharedctype4xi starting ", time4xi())    

    print("modify2xyz of test_sharedctype4xi: passed n ", n)
    print("modify2xyz of test_sharedctype4xi: passed vector ", vector)
    
    n.value **= 3
    
    for a in vector:
        a.x **= 3
        a.y **= 3
        a.z **= 3

    print("modify2xyz of test_sharedctype4xi returning ", time4xi())    
#</function4>
 
                
# -------------------------------------------------------------------------------------------------
#<function4xi function = "modify2xyz4xi" usage = "
# modify 3-dimension structure with all types 
#"
#>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------     
def modify2xyz4xi(n, vector):
    print("modify2xyz4xi of test_sharedctype4xi starting ", time4xi())    
    # 06:41:03 04/15/13 Pacific Daylight Time
    
    print("modify2xyz4xi of test_sharedctype4xi: passed n ", n)
    # <Synchronized4Xi wrapper for c_long(8)>
    print("modify2xyz4xi of test_sharedctype4xi: passed vector ", vector)
    # <SynchronizedArray4Xi wrapper for <rawarray4xi.ThreeDimension3Xi_Array_3 object at 0x0000000003925B48>>
    n.value **= 3
    
    for a in vector:
        a.x **= 3
        a.y **= 3
        a.z **= 3
        
    print("modify2xyz4xi of test_sharedctype4xi returning ", time4xi())     
    # 06:41:03 04/15/13 Pacific Daylight Time
#</function4xi>
 
        
        
# -------------------------------------------------------------------------------------------------
#<function function = "test-shared-ctypes" usage = "
# testing shared c-types in multiprocessing
#"> 
#<state status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def test_shared_ctypes():

    # ---------------------------------------------------------------------------------------------
    # (STEP 1/12) - OK
    # ---------------------------------------------------------------------------------------------  
    print("(STEP 1A/12) OF ORIGINAL TEST_SHARED_CTYPES - CREATING LOCK WITH LOCK ", time4xi())        
    # 05:49:57 04/13/13 Pacific Daylight Time   
    try:
        lock2xi = Lock()
        
        print("(STEP 1B/12) OF ORIGINAL TEST_SHARED_CTYPES -  CREATED LOCK2XI:  ", lock2xi)
        # <Lock(owner=None)> 
        
    except:
        print("(STEP 1Z/12) OF ORIGINAL TEST_SHARED_CTYPES - *** FAILED TO CREATE LOCK *** ", time4xi())          
    
    # -----------------------------------------------------------------------------------------    
    # (STEP 2/12) - OK
    # -----------------------------------------------------------------------------------------        
    print("(STEP 2A/12) OF ORIGINAL TEST_SHARED_CTYPES - CREATING INTEGER2SYNC WITH VALUE ", time4xi())
    # 05:49:57 04/13/13 Pacific Daylight Time 
    integer2sync = None
    
    try: 
        # ------------------------------------------------------------------------------------- 
        # OK
        # ------------------------------------------------------------------------------------- 
        integer2sync = Value('i', 7)
        
        print("(STEP 2B/12): OF ORIGINAL TEST_SHARED_CTYPES - CREATED INTEGER2SYNC ", integer2sync)
        # <Synchronized wrapper for c_long(7)>
    except:
        print("(STEP 2Z1/12): OF ORIGINAL TEST_SHARED_CTYPES -  *** FAILED TO CREATE DOUBLE2SYNC *** ", time4xi())
          
    try:    
        # ------------------------------------------------------------------------------------- 
        # OK
        # ------------------------------------------------------------------------------------- 
        print("(STEP  2C/12): OF ORIGINAL TEST_SHARED_CTYPES - CREATING DOUBLE2SYNC WITH VALUE ", time4xi())  
        # 05:49:57 04/13/13 Pacific Daylight Time
        
        double2sync = Value(c_double, 1.0/3.0, lock=lock2xi)
        
        print("(STEP  2D/12): OF ORIGINAL TEST_SHARED_CTYPES - CREATED DOUBLE2SYNC WITH VALUE ", time4xi())            
        print(double2sync)
        # <Synchronized wrapper for c_double(0.3333333333333333)>
        
    except:
        print("(STEP 2Z2/12): OF ORIGINAL TEST_SHARED_CTYPES -  *** FAILED TO CREATE DOUBLE2SYNC *** ", time4xi())  
    
    # -----------------------------------------------------------------------------------------    
    # (STEP 4/12) - OK
    # -----------------------------------------------------------------------------------------        
    print("(STEP 4A/12): OF ORIGINAL TEST_SHARED_CTYPES -  CREATING ARRAY2SYNC ", time4xi())                
    # 05:49:57 04/13/13 Pacific Daylight Time
    array2sync = None
    
    try:
    
        array2sync = Array(Point, [(1.875,-6.25,21.1), (-5.75,2.0,42.2), (2.375,9.5,84.4)], lock=lock2xi)
        
        print("(STEP 4B/12): OF ORIGINAL TEST_SHARED_CTYPES -  CREATED ARRAY2SYNC WITH ARRAY:  ", array2sync) 
        # <SynchronizedArray wrapper for <multiprocessing.sharedctypes.Point_Array_3 object at 0x00000000039D4F48>>
    except:
        print("(STEP 4Z1/12): OF ORIGINAL TEST_SHARED_CTYPES -   *** FAILED TO CREATE ARRAY2SYNC *** ", time4xi())  
    
        
    # -----------------------------------------------------------------------------------------    
    # (Step 5/12)
    # -----------------------------------------------------------------------------------------        
    print("(STEP 5A/12): OF ORIGINAL TEST_SHARED_CTYPES - USING PROCESS ", time4xi())                     
    # 05:49:57 04/13/13 Pacific Daylight Time 
    try:    
        buffer2sync = create_string_buffer(70)
    except:
        print("(STEP 5Z12/12): OF ORIGINAL TEST_SHARED_CTYPES *** FAILED TO CREATE BUFFER2SYNC ", time4xi())
    try:        
        buffer2sync.value = b"Hello"
        print("(STEP 5B/12): OF ORIGINAL TEST_SHARED_CTYPES - BUFFER2SYNC ", buffer2sync.value)
        # b'Hello'
    except:
        print("(STEP 5Z13/12): OF ORIGINAL TEST_SHARED_CTYPES *** FAILED TO SET BUFFER2SYNC VALUE", time4xi()) 
        
    try:
        print("(STEP 5C/12): OF ORIGINAL TEST_SHARED_CTYPES - CALLING MODIFY ", modify)
        # <function modify at 0x0000000003A94BF8>
        modify(integer2sync, double2sync, buffer2sync, array2sync)
        print("(STEP 5D/12): OF ORIGINAL TEST_SHARED_CTYPES - PERFORMED MODIFY ", modify)
        # <function modify at 0x0000000003A94BF8>
    except:
        print("(STEP 5Z2/12): OF ORIGINAL TEST_SHARED_CTYPES *** FAILED TO PERFORM MODIFY ", modify)        
        
    try:
        print("(STEP 5E/12): OF ORIGINAL TEST_SHARED_CTYPES - CREATING PROCESS2CTYPES ", time4xi())
        # 05:49:57 04/13/13 Pacific Daylight Time
        print("(STEP 5F/12): OF ORIGINAL TEST_SHARED_CTYPES - TARGET ", modify)
        # <function modify at 0x0000000003A94BF8>
        process2ctypes = Process(target=modify, args=(integer2sync, double2sync, buffer2sync, array2sync))
        
        print("(STEP 5G/12): OF ORIGINAL TEST_SHARED_CTYPES - CREATED PROCESS2CTYPES: ", process2ctypes)
        # <Process(Process-1, initial)>
    except:
        print("(STEP 5Z3/12) OF ORIGINAL TEST_SHARED_CTYPES - *** FAILED TO CREATE PROCESS2CTYPES *** ", time4xi()) 
         
    ack2start = True
    if ack2start is True:    
        try:           
            print("(STEP 5H1/12): OF ORIGINAL TEST_SHARED_CTYPES - STARTING PROCESS2CTYPES ", time4xi()) 
            # 05:49:57 04/13/13 Pacific Daylight Time 
            process2ctypes.start()
            print("(STEP 5I/12): OF ORIGINAL TEST_SHARED_CTYPES - STARTED PROCESS2CTYPES ", time4xi())
            #    
        except:
            print("(STEP 5Z4/12e) OF ORIGINAL TEST_SHARED_CTYPES - *** FAILED TO START PROCESS2CTYPES *** ", time4xi())  
            # 
    else:
        print("(STEP 5H2/12): OF ORIGINAL TEST_SHARED_CTYPES - SKIPPED STARTING PROCESS2CTYPES ", time4xi())
                
    ack2run = False
    if ack2run is True:        
        try:           
            print("(STEP 5G1/12): OF ORIGINAL TEST_SHARED_CTYPES - RUNNING PROCESS2CTYPES ", time4xi())   
            # 
            process2ctypes.run()
            
            print("(STEP 5H/12): OF ORIGINAL TEST_SHARED_CTYPES - RUN PROCESS2CTYPES ", time4xi())
            # 
        except:
            print("(STEP 5Z4/12) OF ORIGINAL TEST_SHARED_CTYPES - : *** FAILED TO RUN PROCESS2CTYPES *** ", time4xi()) 
    else:
        print("(STEP 5G2/12): OF ORIGINAL TEST_SHARED_CTYPES - SKIPPED RUNNING PROCESS2CTYPES ", time4xi())
        # 05:49:57 04/13/13 Pacific Daylight Time
                    
    # -----------------------------------------------------------------------------------------    
    # (Step 6/12) - OK 
    # -----------------------------------------------------------------------------------------        
    print("(STEP 6A/12): OF ORIGINAL TEST_SHARED_CTYPES -  PRINTING VALUES WITH PROCESS2CTYPES ", time4xi()) 
    try: 
        print("INTEGER2SYNC.VALUE: ",integer2sync.value)
        # INTEGER2SYNC.VALUE:  49
    except:
        print("(STEP 6Z1/12): OF ORIGINAL TEST_SHARED_CTYPES -  *** FAILED TO PRINT VALUES WITH PROCESS2CTYPES*** ", time4xi())
          
    try:
        print("DOUBLE2SYNC.VALUE: ",double2sync.value)
        # DOUBLE2SYNC.VALUE:  0.1111111111111111   
    except:
        print("(STEP 6Z2/12): OF ORIGINAL TEST_SHARED_CTYPES -  *** FAILED TO PRINT VALUES WITH PROCESS2CTYPES*** ", time4xi())             
    try:
        print("BUFFER2SYNC.VALUE: ",buffer2sync.value)
        # BUFFER2SYNC.VALUE:  b'Hello@yourdragonxi'
    except:
        print("(STEP 6Z2/12): OF ORIGINAL TEST_SHARED_CTYPES -  *** FAILED TO PRINT VALUES WITH PROCESS2CTYPES*** ", time4xi())                 
    try:    
        print("ARRAY2SYNC X,Y,Z: ")
        print ([(a.x, a.y, a.z) for a in array2sync])
        # [(3.515625, 1525.87890625, 39287974783.90154), (33.0625, 16.0, 10057721544678.795), (5.640625, 8145.0625, 2574776715437771.5)]
        print("(STEP 6/12B): OF ORIGINAL TEST_SHARED_CTYPES -  PRINTED VALUES WITH PROCESS2CTYPES ", time4xi())            
       
    except:
        print("(STEP 6Z4/12): OF ORIGINAL TEST_SHARED_CTYPES -  *** FAILED TO PRINT VALUES WITH PROCESS2CTYPES*** ", time4xi())    
    # -----------------------------------------------------------------------------------------    
    # (Step 7/12): OK 
    # -----------------------------------------------------------------------------------------                 
    print("(STEP 7A/12): OF ORIGINAL TEST_SHARED_CTYPES -  EXPLORING WITH 3D COORDINATES ", time4xi())
    # 05:49:57 04/13/13 Pacific Daylight Time        
    try:
        lock3D = Lock()
        print("(STEP 7/12C): OF ORIGINAL TEST_SHARED_CTYPES -  CREATED LOCK3D: ", str(lock3D)) 
        # <Lock(owner=None)>
         
    except:
        print("(STEP 7Z1/12): OF ORIGINAL TEST_SHARED_CTYPES -  EXCEPTION *** FAILED TO CREATE LOCK *** ", time4xi())

    # -----------------------------------------------------------------------------------------    
    # (Step 8/12):
    # -----------------------------------------------------------------------------------------                 
    print("(STEP Step 8A/12): OF ORIGINAL TEST_SHARED_CTYPES -  CREATING NUMBER3D ", time4xi())
    # 05:49:57 04/13/13 Pacific Daylight Time        
    try:
    
        number3D = Value('i', 8)
        print("(STEP Step 8B/12): OF ORIGINAL TEST_SHARED_CTYPES -  CREATED NUMBER3D: ", str(number3D))
        # <Synchronized wrapper for c_long(8)>     
        
    except:
        print("(STEP 8Z1/12): OF ORIGINAL TEST_SHARED_CTYPES -  *** FAILED TO CREATE VALUE *** ", time4xi())
    
    # -----------------------------------------------------------------------------------------    
    # (Step 9/12): OK 
    # -----------------------------------------------------------------------------------------                 
    print("(STEP 9A/12): OF ORIGINAL TEST_SHARED_CTYPES -  CREATING DOUBLE3D ", time4xi())
    # 05:49:57 04/13/13 Pacific Daylight Time         
    try:       
        double3d = Value(c_double, 1.0/3.0, lock=lock3D)
        print("(STEP 9B/12): OF ORIGINAL TEST_SHARED_CTYPES -  CREATED DOUBLE3D: ", str(double3d))
        # <Synchronized wrapper for c_double(0.3333333333333333)>   
 
    except:
        print("(STEP 9Z1/12): OF ORIGINAL TEST_SHARED_CTYPES -  *** FAILED TO CREATE DOUBLE3D *** ", time4xi())
                

    # -----------------------------------------------------------------------------------------    
    # Step 10/12: OK  
    # -----------------------------------------------------------------------------------------                 
    print("(STEP 10A/12): OF ORIGINAL TEST_SHARED_CTYPES -  TRYING TO CREATE STRING3D ", time4xi())  
    # 05:49:57 04/13/13 Pacific Daylight Time
    try:
        string3D = create_string_buffer(b"Hello3D")
        print("(STEP 10/12B): OF ORIGINAL TEST_SHARED_CTYPES -  CREATED STRING3D: ", str(string3D))
        # <ctypes.c_char_Array_8 object at 0x0000000003AED048>
    except:
        print("(STEP 10/12Z1): OF ORIGINAL TEST_SHARED_CTYPES -   *** FAILED TO CREATE STRING3D *** ", time4xi())            

    
    # -----------------------------------------------------------------------------------------    
    # Step 11/12: OK 
    # -----------------------------------------------------------------------------------------                 
    print("(STEP 11A/12): OF ORIGINAL TEST_SHARED_CTYPES -  TRYING TO CREATE ARRAY3D  ", time4xi())                      
    # 05:49:57 04/13/13 Pacific Daylight Time 
    try:
    
        array3D = Array(ThreeDimension, [(1.875,-6.25,2.00), (-5.75,2.0,3.00), (2.375,9.5,4.0)], lock=lock3D)
        
        print("(STEP 11B/12): OF ORIGINAL TEST_SHARED_CTYPES -  CREATED ARRAY3D: ", str(array3D))
        # <SynchronizedArray wrapper for <multiprocessing.sharedctypes.ThreeDimension_Array_3 object at 0x0000000003AC40C8>>
    except:
        print("(STEP 11Z/12): OF ORIGINAL TEST_SHARED_CTYPES -   *** FAILED TO CREATE ARRAY3D *** ", time4xi()) 
                
    # -----------------------------------------------------------------------------------------    
    # Step 12/12: OK 
    # -----------------------------------------------------------------------------------------                 
    print("(STEP 12A/12) OF ORIGINAL TEST_SHARED_CTYPES -   3D TESTING  ", time4xi())  
    # 05:49:57 04/13/13 Pacific Daylight Time
    try:
    
        print("(STEP 12B/12): OF ORIGINAL TEST_SHARED_CTYPES -  CREATING PROCESS3XYZ ", time4xi())
        # 05:49:57 04/13/13 Pacific Daylight Time      
        process3xyz = Process(target=modify2xyz, args=(number3D, array3D))
        
        print("(STEP 12C/12): OF ORIGINAL TEST_SHARED_CTYPES -  CREATED PROCESS3XYZ: ", process3xyz) 
        # 05:49:57 04/13/13 Pacific Daylight Time
    except:
        print("(STEP 11Z/12): OF ORIGINAL TEST_SHARED_CTYPES -   *** FAILED TO CREATE PROCESS3XYZ *** ", time4xi()) 
         
    try:           
        
        print("(STEP 12D/12): OF ORIGINAL TEST_SHARED_CTYPES -  STARTING PROCESS3XYZ ", time4xi())                         
        # 05:49:57 04/13/13 Pacific Daylight Time 
        process3xyz.start()
        
        print("(STEP 12E/12): OF ORIGINAL TEST_SHARED_CTYPES -  STARTED PROCESS3XYZ ", time4xi()) 
        # 05:49:57 04/13/13 Pacific Daylight Time
    except:
        print("(STEP 11Z/12): OF ORIGINAL TEST_SHARED_CTYPES -   *** FAILED TO START PROCESS3XYZ *** ", time4xi())
        
         
    try:    
        
        print("(STEP 12G/12): OF ORIGINAL TEST_SHARED_CTYPES -  JOINING PROCESS3XYZ ", time4xi())            
        # 05:49:57 04/13/13 Pacific Daylight Time 
        process3xyz.join()
        
        print("(STEP 12H/12): OF ORIGINAL TEST_SHARED_CTYPES -  JOINED PROCESS3XYZ ", time4xi())
        # 05:49:57 04/13/13 Pacific Daylight Time
    except:
        print("(STEP 12Z1/12): OF ORIGINAL TEST_SHARED_CTYPES -   *** FAILED TO START PROCESS3XYZ *** ", time4xi())
    
    print("(STEP 12J/12): OF ORIGINAL TEST_SHARED_CTYPES -  STARTING TO PRINT VALUES USING CREATED OBJECTS ", time4xi())       
    # 05:49:57 04/13/13 Pacific Daylight Time
    try:    
        print("number3D.VALUE: ",number3D.value)
        # 512
    except:
        print("(STEP 12Z2/12): OF ORIGINAL TEST_SHARED_CTYPES -   *** FAILED WITH 3D ", time4xi())
    
    try:         
        print("DOUBLE3D.VALUE: ",double3d.value)
        # 0.3333333333333333
    except:
        print("(STEP 12Z3/12): OF ORIGINAL TEST_SHARED_CTYPES -   *** FAILED WITH 3D ", time4xi()) 
     
    try:        
        print("ARRAY3D: ")
        print ([(a.x, a.y, a.z) for a in array3D])
        print("(STEP 12/12k): OF ORIGINAL TEST_SHARED_CTYPES -  EXPLORED OK WITH 3D COORDINATEs ", time4xi())
        # [(6.591796875, -244.140625, 8.0), (-190.109375, 8.0, 27.0), (13.396484375, 857.375, 64.0)]
    except:
        print("(STEP 12Z5/12): OF ORIGINAL TEST_SHARED_CTYPES -   *** FAILED WITH 3D ", time4xi()) 
        
    # -----------------------------------------------------------------------------------------    
    # Step 14/12: 
    # -----------------------------------------------------------------------------------------   
 
    try:  
        print("(STEP 14A/12): OF ORIGINAL TEST_SHARED_CTYPES - TERMINATING PROCESS2CTYPES: ", process2ctypes)                
        # <Process(Process-1, initial)>  
        process2ctypes.terminate()
        
        print("(STEP 14B/12): OF ORIGINAL TEST_SHARED_CTYPES - TERMINATED PROCESS2CTYPES ", time4xi())            
        # 
    except:
        print("(STEP 14Z1/12): OF ORIGINAL TEST_SHARED_CTYPES -  FAILED TO TERMINATE PROCESS2CTYPES ", time4xi())         
 
    try: 
           
        print("(STEP 14C/12): OF ORIGINAL TEST_SHARED_CTYPES - TERMINATING PROCESS3XYZ: ", process3xyz)                
        # <Process(Process-2, stopped)>  
        process3xyz.terminate()
        
        print("(STEP 14D/12): OF ORIGINAL TEST_SHARED_CTYPES - TERMINATED PROCESS3XYZ ", time4xi())
        #             
    except:
        print("(STEP 14Z2/12): OF ORIGINAL TEST_SHARED_CTYPES -  FAILED TO TERMINATE PROCESS3XYZ ", time4xi())         
 
       

#</function>
  

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-shared-ctypes4xi" usage = "
# testing shared c-types in multiprocessing
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def test_shared_ctypes4xi():
    global KB4Examination
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A/33) OF SHARED_CTYPES4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:

        # ---------------------------------------------------------------------------------------------
        # (STEP 0/12) - HYPRID APPROACH - DECIDE WHICH MODULE VERSIONS YOU WANT TO TEST!
        # ---------------------------------------------------------------------------------------------  
        print("(STEP 0A/12) OF HYBRID TEST_SHARED_CTYPES4XI - SETTING VERSIONS TO BE TESTED ", time4xi())
        # 06:41:02 04/15/13 Pacific Daylight Time
        ack2hybrid = False
        if ack2hybrid is True:
            keys2examine = kb2select4test.keys()
            for key2examine in keys2examine:
                KB4Examination [key2examine] = True
            print("(STEP 0B/12) OF HYBRID TEST_SHARED_CTYPES4XI - DECIDED TO USE HYBRID MULTIPROCESSING ", time4xi())
            # 04:19:13 04/13/13 Pacific Daylight Time <-- ALL NEW MODULES    
        else:
            print("(STEP 0C/12) OF HYBRID TEST_SHARED_CTYPES4XI - DECIDED TO USE TOTALLY MULTIPROCESSING4XI ", time4xi())    
            # 06:41:02 04/15/13 Pacific Daylight Time
            
        # ---------------------------------------------------------------------------------------------
        # (STEP 1/12) - OK (WITH ORIGINAL ONLY IF SEMLOCK EXCEPTION ALLOWED)
        # ---------------------------------------------------------------------------------------------  
        print("(STEP 1A/12) OF HYBRID TEST_SHARED_CTYPES4XI - CREATING LOCK_XI2 WITH LOCK4XI ", time4xi())        
        # 06:41:02 04/15/13 Pacific Daylight Time
        try:

            lock_xi2 = Lock4Xi()
            
            print("(STEP 1B/12) OF HYBRID TEST_SHARED_CTYPES4XI -  CREATED LOCK_XI2:  ", lock_xi2)
            # <Lock(owner=None)> 
            
        except:
            print("(STEP 1Z/12) OF HYBRID TEST_SHARED_CTYPES4XI - *** FAILED TO CREATE LOCK_XI2 *** ", time4xi())          
        
        # -----------------------------------------------------------------------------------------    
        # (STEP 2/12) - OK
        # -----------------------------------------------------------------------------------------        
        print("(STEP 2A/12) OF HYBRID TEST_SHARED_CTYPES4XI - CREATING INTEGER2SYNC WITH VALUEFUNCTION4XI ", time4xi()) 
        # 06:41:02 04/15/13 Pacific Daylight Time
        integer2sync = None
        
        try: 
            # ------------------------------------------------------------------------------------- 
            # OK - NEW TOO
            # ------------------------------------------------------------------------------------- 
            integer2sync = ValueFunction4Xi('i', 7)
            
            print("(STEP 2B/12): OF HYBRID TEST_SHARED_CTYPES4XI - CREATED INTEGER2SYNC ", integer2sync)
            # <Synchronized wrapper for c_long(7)>
            # <Synchronized4Xi wrapper for c_long(7)>
        except:
            print("(STEP 2Z1/12): OF HYBRID TEST_SHARED_CTYPES4XI -  *** FAILED TO CREATE DOUBLE2SYNC *** ", time4xi())
              
        try:    
            # ------------------------------------------------------------------------------------- 
            # OK - NEW TOO
            # ------------------------------------------------------------------------------------- 
            print("(STEP  2C/12): OF HYBRID TEST_SHARED_CTYPES4XI - CREATING DOUBLE2SYNC WITH VALUEFUNCTION4XI ", time4xi()) 
            
            # double2sync = ValueFunction4Xi(c_double, 1.0/3.0, lock=lock_xi2) <-- you have to omit this parameter
            double2sync = ValueFunction4Xi(c_double, 1.0/3.0)
            
            print("(STEP  2D/12): OF HYBRID TEST_SHARED_CTYPES4XI - CREATED DOUBLE2SYNC WITH VALUEFUNCTION4XI ", time4xi())            
            print(double2sync)
            # <Synchronized wrapper for c_double(0.3333333333333333)>
            # <Synchronized4Xi wrapper for c_double(0.3333333333333333)>
            
        except:
            print("(STEP 2Z2/12): OF HYBRID TEST_SHARED_CTYPES4XI -  *** FAILED TO CREATE DOUBLE2SYNC *** ", time4xi())  
        

        # -----------------------------------------------------------------------------------------    
        # (STEP 4/12) - NEW TOO
        # -----------------------------------------------------------------------------------------        
        print("(STEP 4A/12): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATING ARRAY2SYNC ", time4xi())                
        # 06:15:13 04/15/13 Pacific Daylight Time
        array2sync = None
        try:
        
            array2sync = ArrayFunction4Xi(Point4Xi, [(1.875,-6.25,21.1), (-5.75,2.0,42.2), (2.375,9.5,84.4)])
            
            print("(STEP 4B/12): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATED ARRAY2SYNC WITH ARRAYFUNCTION4XI:  ", array2sync) 
            # <SynchronizedArray wrapper for <multiprocessing.sharedctypes.Point4Xi_Array_3 object at 0x0000000003A0C048>>
            # <SynchronizedArray4Xi wrapper for <rawarray4xi.Point4Xi_Array_3 object at 0x0000000003925848>>
        except:
            print("(STEP 4Z1/12): OF HYBRID TEST_SHARED_CTYPES4XI -   *** FAILED TO CREATE ARRAY2SYNC *** ", time4xi())  
        
            
        # -----------------------------------------------------------------------------------------    
        # (Step 5/12)
        # -----------------------------------------------------------------------------------------        
        print("(STEP 5A/12): OF HYBRID TEST_SHARED_CTYPES4XI - USING PROCESS4XI ", time4xi())                     
        # 06:41:02 04/15/13 Pacific Daylight Time
        try:    
            buffer2sync = create_string_buffer(70)
        except:
            print("(STEP 5Z12/12): OF HYBRID TEST_SHARED_CTYPES4XI *** FAILED TO CREATE BUFFER2SYNC ", time4xi())
        try:        
            buffer2sync.value = b"Hello"
            print("(STEP 5B/12): OF HYBRID TEST_SHARED_CTYPES4XI - BUFFER2SYNC ", buffer2sync.value)
            # b'Hello'
        except:
            print("(STEP 5Z13/12): OF HYBRID TEST_SHARED_CTYPES4XI *** FAILED TO SET BUFFER2SYNC VALUE", time4xi()) 
            
        try:
            print("(STEP 5C/12): OF HYBRID TEST_SHARED_CTYPES4XI - CALLING MODIFY4XI ", modify4xi)
            # <function modify4xi at 0x0000000003835EA0>   
            modify4xi(integer2sync, double2sync, buffer2sync, array2sync)
            print("(STEP 5D/12): OF HYBRID TEST_SHARED_CTYPES4XI - PERFORMED MODIFY4XI ", modify4xi)
            # <function modify4xi at 0x0000000003835EA0>      
        except:
            print("(STEP 5Z2/12): OF HYBRID TEST_SHARED_CTYPES4XI *** FAILED TO PERFORM MODIFY4XI ", modify4xi)        
            
        try:
            print("(STEP 5E/12): OF HYBRID TEST_SHARED_CTYPES4XI - CREATING PROCESS2CTYPES ", time4xi()) 
            # 06:41:02 04/15/13 Pacific Daylight Time
            print("(STEP 5F/12): OF HYBRID TEST_SHARED_CTYPES4XI - TARGET ", modify4xi)
            # <function modify4xi at 0x00000000037E7620> 
            process2ctypes = Process4Xi(target=modify4xi, args=(integer2sync, double2sync, buffer2sync, array2sync))
            
            print("(STEP 5G/12): OF HYBRID TEST_SHARED_CTYPES4XI - CREATED PROCESS2CTYPES: ", process2ctypes)
            # { Process4Xi : __repr__ ; started; repr-of-Process4Xi-started: ; time: 06:41:02 04/15/13 Pacific Daylight Time}
            # <Process4Xi(Process4Xi-1, initial)>
        except:
            print("(STEP 5Z3/12) OF HYBRID TEST_SHARED_CTYPES4XI - *** FAILED TO CREATE PROCESS2CTYPES *** ", time4xi())  
            

        try:           
            print("(STEP 5H/12): OF HYBRID TEST_SHARED_CTYPES4XI - STARTING PROCESS2CTYPES ", time4xi())
            # 06:41:02 04/15/13 Pacific Daylight Time
            process2ctypes.start()
            print("(STEP 5I/12): OF HYBRID TEST_SHARED_CTYPES4XI - STARTED PROCESS2CTYPES ", time4xi())
            # { Process4Xi : start ; (Step 7/7) returning; start-of-Process4Xi-returning: 06:41:03 04/15/13 Pacific Daylight Time}  

        except:
            print("(STEP 5Z4/12e) OF HYBRID TEST_SHARED_CTYPES4XI - *** FAILED TO START PROCESS2CTYPES *** ", time4xi())  
            
        try:           
            print("(STEP 5G/12): OF HYBRID TEST_SHARED_CTYPES4XI - RUNNING PROCESS2CTYPES ", time4xi())   
            # 06:41:03 04/15/13 Pacific Daylight Time
            process2ctypes.run()
            
            # { Process4Xi : run ; Step (1/2a) calling; target-of-process2xi-calling-by-run-of-Process4Xi: <function modify4xi at 0x0000000003923E18>; time: 06:41:03 04/15/13 Pacific Daylight Time}
            # (STEP 0A/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: started  06:41:03 04/15/13 Pacific Daylight Time
            # (STEP 0B/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: PASSED INT2MODIFY  <Synchronized4Xi wrapper for c_long(49)>
            # (STEP 0C/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: PASSED DOUBLE2MODIFY  <Synchronized4Xi wrapper for c_double(0.1111111111111111)>
            # (STEP 0D/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: PASSED BUFFER2MODIFY  <ctypes.c_char_Array_70 object at 0x0000000003925A48>
            # (STEP 0E/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: PASSED VECTOR2MODIFY  <SynchronizedArray4Xi wrapper for <rawarray4xi.Point4Xi_Array_3 object at 0x0000000003925848>>
            # (STEP 1A/33) OF MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF INT2MODIFY TO:  2401
            # (STEP 2A/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF DOUBLE2MODIFY TO:  0.012345679012345678
            # (STEP 3A/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF BUFFER2MODIFY TO:  b'Hello@yourdragonxi@yourdragonxi'
            # (STEP 4A/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF X IN VECTOR2MODIFY TO:  12.359619140625
            # (STEP 4B/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF Y IN VECTOR2MODIFY TO:  5421010862427.522
            # (STEP 4C/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF Z IN VECTOR2MODIFY TO:  5.676454211986251e+84
            # (STEP 4A/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF X IN VECTOR2MODIFY TO:  1093.12890625
            # (STEP 4B/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF Y IN VECTOR2MODIFY TO:  65536.0
            # (STEP 4C/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF Z IN VECTOR2MODIFY TO:  1.04712098094641e+104
            # (STEP 4A/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF X IN VECTOR2MODIFY TO:  31.816650390625
            # (STEP 4B/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF Y IN VECTOR2MODIFY TO:  4401266686517657.0
            # (STEP 4C/33) MODIFY4XI OF TEST_SHAREDCTYPE4XI: SET VALUE OF Z IN VECTOR2MODIFY TO:  1.931597274973012e+123
            # (STEP 5/33)MODIFY4XI OF TEST_SHAREDCTYPE4XI: RETURNING   06:41:03 04/15/13 Pacific Daylight Time
            # =================================
            # { Process4Xi : run ; Step (1/2b) performed; target-of-process2xi-performed-by-run-of-Process4Xi: <function modify4xi at 0x0000000003923E18>; time: 06:41:03 04/15/13 Pacific Daylight Time}
            
            print("(STEP 5H/12): OF HYBRID TEST_SHARED_CTYPES4XI - RUN PROCESS2CTYPES ", time4xi())
            # 06:41:03 04/15/13 Pacific Daylight Time
        except:
            print("(STEP 5Z4/12) OF HYBRID TEST_SHARED_CTYPES4XI - : *** FAILED TO RUN PROCESS2CTYPES *** ", time4xi()) 

        # -----------------------------------------------------------------------------------------    
        # (Step 6/12) - OK NEW TOO
        # -----------------------------------------------------------------------------------------        
        print("(STEP 6A/12): OF HYBRID TEST_SHARED_CTYPES4XI -  PRINTING VALUES WITH PROCESS2CTYPES ", time4xi()) 
        try: 
            print("INTEGER2SYNC.VALUE: ",integer2sync.value)
            # INTEGER2SYNC.VALUE:  2401
        except:
            print("(STEP 6Z1/12): OF HYBRID TEST_SHARED_CTYPES4XI -  *** FAILED TO PRINT VALUES WITH PROCESS2CTYPES*** ", time4xi())
              
        try:
            print("DOUBLE2SYNC.VALUE: ",double2sync.value)
            # DOUBLE2SYNC.VALUE:  0.012345679012345678
        except:
            print("(STEP 6Z2/12): OF HYBRID TEST_SHARED_CTYPES4XI -  *** FAILED TO PRINT VALUES WITH PROCESS2CTYPES*** ", time4xi())             
        try:
            print("BUFFER2SYNC.VALUE: ",buffer2sync.value)
            # BUFFER2SYNC.VALUE:  b'Hello@yourdragonxi@yourdragonxi'
        except:
            print("(STEP 6Z2/12): OF HYBRID TEST_SHARED_CTYPES4XI -  *** FAILED TO PRINT VALUES WITH PROCESS2CTYPES*** ", time4xi())                 
        try:    
            print("ARRAY2SYNC X,Y,Z: ")
            print ([(a.x, a.y, a.z) for a in array2sync])
            # [(12.359619140625, 5421010862427.522, 5.676454211986251e+84), (1093.12890625, 65536.0, 1.04712098094641e+104), (31.816650390625, 4401266686517657.0, 1.931597274973012e+123)]
            print("(STEP 6/12B): OF HYBRID TEST_SHARED_CTYPES4XI -  PRINTED VALUES WITH PROCESS2CTYPES ", time4xi())            
           
        except:
            print("(STEP 6Z4/12): OF HYBRID TEST_SHARED_CTYPES4XI -  *** FAILED TO PRINT VALUES WITH PROCESS2CTYPES*** ", time4xi())    
  

        # -----------------------------------------------------------------------------------------    
        # (Step 7/12): OK 
        # -----------------------------------------------------------------------------------------                 
        print("(STEP 7A/12): OF HYBRID TEST_SHARED_CTYPES4XI -  EXPLORING WITH 3D COORDINATES ", time4xi())        
        # 06:41:03 04/15/13 Pacific Daylight Time
        try:
            lock3D = Lock4Xi()
            print("(STEP 7/12C): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATED LOCK3D: ", str(lock3D)) 
            # <Lock(owner=None)>
             
        except:
            print("(STEP 7Z1/12): OF HYBRID TEST_SHARED_CTYPES4XI -  EXCEPTION *** FAILED TO CREATE LOCK4XI *** ", time4xi())
    
        # -----------------------------------------------------------------------------------------    
        # (Step 8/12): OK
        # -----------------------------------------------------------------------------------------                 
        print("(STEP Step 8A/12): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATING NUMBER3D ", time4xi())        
        # 06:41:03 04/15/13 Pacific Daylight Time
        try:
        
            number3D = ValueFunction4Xi('i', 8)
            print("(STEP Step 8B/12): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATED NUMBER3D: ", str(number3D))
            # <Synchronized4Xi wrapper for c_long(8)>
            
        except:
            print("(STEP 8Z1/12): OF HYBRID TEST_SHARED_CTYPES4XI -  *** FAILED TO CREATE VALUEFUNCTION4XI *** ", time4xi())
        
        # -----------------------------------------------------------------------------------------    
        # (Step 9/12): OK
        # -----------------------------------------------------------------------------------------                 
        print("(STEP 9A/12): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATING DOUBLE3D ", time4xi())
        # 06:41:03 04/15/13 Pacific Daylight Time   
        try:       
            double3d = ValueFunction4Xi(c_double, 1.0/3.0)
            print("(STEP 9B/12): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATED DOUBLE3D: ", str(double3d))
            # <Synchronized4Xi wrapper for c_double(0.3333333333333333)>
     
        except:
            print("(STEP 9Z1/12): OF HYBRID TEST_SHARED_CTYPES4XI -  *** FAILED TO CREATE DOUBLE3D *** ", time4xi())
                    
    
        # -----------------------------------------------------------------------------------------    
        # Step 10/12: OK
        # -----------------------------------------------------------------------------------------                 
        print("(STEP 10A/12): OF HYBRID TEST_SHARED_CTYPES4XI -  TRYING TO CREATE STRING3D ", time4xi())  
        # 06:41:03 04/15/13 Pacific Daylight Time
        try:
            string3D = create_string_buffer(b"Hello3D")
            print("(STEP 10/12B): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATED STRING3D: ", str(string3D))
            # <ctypes.c_char_Array_8 object at 0x00000000039256C8>
        except:
            print("(STEP 10/12Z1): OF HYBRID TEST_SHARED_CTYPES4XI -   *** FAILED TO CREATE STRING3D *** ", time4xi())            
    
        
        # -----------------------------------------------------------------------------------------    
        # Step 11/12: OK 
        # -----------------------------------------------------------------------------------------                 
        print("(STEP 11A/12): OF HYBRID TEST_SHARED_CTYPES4XI -  TRYING TO CREATE ARRAY3D  ", time4xi())                      
        # 06:41:03 04/15/13 Pacific Daylight Time
        try:
        
            array3D = ArrayFunction4Xi(ThreeDimension3Xi, [(1.875,-6.25,2.00), (-5.75,2.0,3.00), (2.375,9.5,4.0)])
            
            print("(STEP 11B/12): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATED ARRAY3D: ", str(array3D))
            # <SynchronizedArray4Xi wrapper for <rawarray4xi.ThreeDimension3Xi_Array_3 object at 0x0000000003925B48>>
        except:
            print("(STEP 11Z/12): OF HYBRID TEST_SHARED_CTYPES4XI -   *** FAILED TO CREATE ARRAY3D *** ", time4xi()) 
                    
        # -----------------------------------------------------------------------------------------    
        # Step 12/12: OK 
        # -----------------------------------------------------------------------------------------                 
        print("(STEP 12A/12) OF HYBRID TEST_SHARED_CTYPES4XI -   3D TESTING  ", time4xi())  
        # 06:41:03 04/15/13 Pacific Daylight Time
           
        try:
        
            print("(STEP 12B/12): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATING PROCESS3XYZ ", time4xi())
            # 06:41:03 04/15/13 Pacific Daylight Time
            process3xyz = Process4Xi(target=modify2xyz4xi, args=(number3D, array3D))
            
            # { Process4Xi : __repr__ ; started; repr-of-Process4Xi-started: ; time: 06:41:03 04/15/13 Pacific Daylight Time}
            print("(STEP 12C/12): OF HYBRID TEST_SHARED_CTYPES4XI -  CREATED PROCESS3XYZ: ", process3xyz) 
            # <Process(Process-2, initial)>
        except:
            print("(STEP 11Z/12): OF HYBRID TEST_SHARED_CTYPES4XI -   *** FAILED TO CREATE PROCESS3XYZ *** ", time4xi()) 
             
        try:           
            
            print("(STEP 12D/12): OF HYBRID TEST_SHARED_CTYPES4XI -  STARTING PROCESS3XYZ ", time4xi())                         
            # 06:41:03 04/15/13 Pacific Daylight Time
            process3xyz.start()
            
            print("(STEP 12E/12): OF HYBRID TEST_SHARED_CTYPES4XI -  STARTED PROCESS3XYZ ", time4xi()) 
            # 06:41:03 04/15/13 Pacific Daylight Time
        except:
            print("(STEP 11Z/12): OF HYBRID TEST_SHARED_CTYPES4XI -   *** FAILED TO START PROCESS3XYZ *** ", time4xi())
            
             
        try:    
            
            print("(STEP 12G/12): OF HYBRID TEST_SHARED_CTYPES4XI -  RUNNING PROCESS3XYZ ", time4xi())            
            # 06:41:03 04/15/13 Pacific Daylight Time
            process3xyz.run()
            
            # { Process4Xi : run ; Step (1/2a) calling; target-of-process2xi-calling-by-run-of-Process4Xi: <function modify2xyz4xi at 0x0000000003923F28>; time: 06:41:03 04/15/13 Pacific Daylight Time}
            # modify2xyz4xi of test_sharedctype4xi starting  06:41:03 04/15/13 Pacific Daylight Time
            # modify2xyz4xi of test_sharedctype4xi: passed n  <Synchronized4Xi wrapper for c_long(8)>
            # modify2xyz4xi of test_sharedctype4xi: passed vector  <SynchronizedArray4Xi wrapper for <rawarray4xi.ThreeDimension3Xi_Array_3 object at 0x0000000003925B48>>
            # modify2xyz4xi of test_sharedctype4xi returning  06:41:03 04/15/13 Pacific Daylight Time
            # { Process4Xi : run ; Step (1/2b) performed; target-of-process2xi-performed-by-run-of-Process4Xi: <function modify2xyz4xi at 0x0000000003923F28>; time: 06:41:03 04/15/13 Pacific Daylight Time}
            
            print("(STEP 12H/12): OF HYBRID TEST_SHARED_CTYPES4XI -  RUN PROCESS3XYZ ", time4xi())
            # 06:41:03 04/15/13 Pacific Daylight Time
        except:
            print("(STEP 12Z1/12): OF HYBRID TEST_SHARED_CTYPES4XI -   *** FAILED TO START PROCESS3XYZ *** ", time4xi())
        
        print("(STEP 12J/12): OF HYBRID TEST_SHARED_CTYPES4XI -  STARTING TO PRINT VALUES USING CREATED OBJECTS ", time4xi())       
        # 06:41:03 04/15/13 Pacific Daylight Time
        try:    
            print("number3D.VALUE: ",number3D.value)
            # 512
        except:
            print("(STEP 12Z2/12): OF HYBRID TEST_SHARED_CTYPES4XI -   *** FAILED WITH 3D ", time4xi())
        
        try:         
            print("DOUBLE3D.VALUE: ",double3d.value)
            # 0.3333333333333333
        except:
            print("(STEP 12Z3/12): OF HYBRID TEST_SHARED_CTYPES4XI -   *** FAILED WITH 3D ", time4xi()) 
         
        try:        
            print("ARRAY3D: ")
            print ([(a.x, a.y, a.z) for a in array3D])
            print("(STEP 12/12k): OF HYBRID TEST_SHARED_CTYPES4XI -  EXPLORED OK WITH 3D COORDINATEs ", time4xi())
            # [(6.591796875, -244.140625, 8.0), (-190.109375, 8.0, 27.0), (13.396484375, 857.375, 64.0)]
        except:
            print("(STEP 12Z5/12): OF HYBRID TEST_SHARED_CTYPES4XI -   *** FAILED WITH 3D ", time4xi()) 

        # -----------------------------------------------------------------------------------------    
        # Step 14/12: 
        # -----------------------------------------------------------------------------------------   
     
        try:  
            print("(STEP 14A/12): OF HYBRID TEST_SHARED_CTYPES4XI - TERMINATING PROCESS2CTYPES: ", process2ctypes)                
            # <Process(Process-1, initial)>  
            process2ctypes.terminate()
            
            print("(STEP 14B/12): OF HYBRID TEST_SHARED_CTYPES4XI - TERMINATED PROCESS2CTYPES ", time4xi())            
            # 06:41:03 04/15/13 Pacific Daylight Time
        except:
            print("(STEP 14Z1/12): OF HYBRID TEST_SHARED_CTYPES4XI -  FAILED TO TERMINATE PROCESS2CTYPES ", time4xi())         
     
        try: 
               
            print("(STEP 14C/12): OF HYBRID TEST_SHARED_CTYPES4XI - TERMINATING PROCESS3XYZ: ", process3xyz)                
            # <Process(Process-2, stopped)>   
            process3xyz.terminate()
            
            print("(STEP 14D/12): OF HYBRID TEST_SHARED_CTYPES4XI - TERMINATED PROCESS3XYZ ", time4xi())
            # 06:41:03 04/15/13 Pacific Daylight Time          
        except:
            print("(STEP 14Z2/12): OF HYBRID TEST_SHARED_CTYPES4XI -  FAILED TO TERMINATE PROCESS3XYZ ", time4xi())         
     
                                            
    # ---------------------------------------------------------------------------------------------    
    # 
    # ---------------------------------------------------------------------------------------------                     
    finally:        
            
        # -----------------------------------------------------------------------------------------    
        # PRINT TRACE
        # -----------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
           
    
#</function4xi>
  
           

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
# main function for testing shared c types
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def main():

    print('=' *33)
    print("SENSING SHARED CTYPES WITH YOURDRAGONXI! ", time4xi())    
    print('=' *33)
    # 05:24:58 04/13/13 Pacific Daylight Time
    
    ack2original = False
    if ack2original is True:
        print("SENSING SHARED CTYPES WITH ORIGINAL MULTIPROCESSING! ", time4xi())
        # 05:26:39 04/13/13 Pacific Daylight Time
        
        test_shared_ctypes()
        
        print("SENSED SHARED CTYPES WITH ORIGINAL MULTIPROCESSING! ", time4xi()) 
        # 06:13:09 04/13/13 Pacific Daylight Time <-- EOFError in pickle.py in load!
        
    ack2hybrid = True
    if ack2hybrid is True:
        print("SENSING SHARED CTYPES WITH HYBRID MULTIPROCESSING! ", time4xi())
        # 05:24:58 04/13/13 Pacific Daylight Time <-- all modules called were original ones!
        
        test_shared_ctypes4xi()       
        
        print("SENSED SHARED CTYPES WITH ORIGINAL MULTIPROCESSING! ", time4xi())
        # 05:24:58 04/13/13 Pacific Daylight Time
          

#</function4xi> 
          

# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   testing shared ctypes
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
#">     
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</function4xi>   

    

#</program4xi> 
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_sharedctypes4xi.txt
#   sense-test-shared-ctypes4xi.xml
#   reason-test-shared-ctypes4xi.xml
#   ace-test-shared-ctypes4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_shared_ctypes4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
